/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.21 Revision 1.56
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.21 2006/05/02 15:04:03 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.56 2008/04/21 02:45:45 zzam Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org>
7 8
8# vdr-plugin.eclass 9# vdr-plugin.eclass
9# 10#
10# eclass to create ebuilds for vdr plugins 11# eclass to create ebuilds for vdr plugins
11# 12#
36# Installation of an rc-addon file for the plugin 37# Installation of an rc-addon file for the plugin
37# 38#
38# If ${VDR_RCADDON_FILE} is set install this file 39# If ${VDR_RCADDON_FILE} is set install this file
39# else install ${FILESDIR}/rc-addon.sh if it exists. 40# else install ${FILESDIR}/rc-addon.sh if it exists.
40# 41#
41# Gets installed under /usr/lib/vdr/rcscript/plugin-${VDRPLUGIN}.sh 42# Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh
42# (in example vdr-femon this would be /usr/lib/vdr/rcscript/plugin-femon.sh) 43# (in example vdr-femon this would be /usr/share/vdr/rcscript/plugin-femon.sh)
43# 44#
44# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr 45# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr
45# It could be used for special startup actions for this plugins, or to create the 46# It could be used for special startup actions for this plugins, or to create the
46# plugin command line options from a nicer version of a conf.d file. 47# plugin command line options from a nicer version of a conf.d file.
47 48
49# HowTo use own local patches; Example
50#
51# Add to your /etc/make.conf:
52# VDR_LOCAL_PATCHES_DIR="/usr/local/patch"
53#
54# Add two DIR's in your local patch dir, ${PN}/${PV},
55# e.g for vdr-burn-0.1.0 should be:
56# /usr/local/patch/vdr-burn/0.1.0/
57#
58# all patches which ending on diff or patch in this DIR will automatically applied
59#
60
48inherit base eutils flag-o-matic 61inherit base multilib eutils flag-o-matic
49 62
50IUSE="debug" 63IUSE=""
51 64
52# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes 65# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes
53VDRPLUGIN="${PN/#vdrplugin-/}" 66VDRPLUGIN="${PN/#vdrplugin-/}"
54VDRPLUGIN="${VDRPLUGIN/#vdr-/}" 67VDRPLUGIN="${VDRPLUGIN/#vdr-/}"
55VDRPLUGIN="${VDRPLUGIN/%-cvs/}" 68VDRPLUGIN="${VDRPLUGIN/%-cvs/}"
58 71
59# works in most cases 72# works in most cases
60S="${WORKDIR}/${VDRPLUGIN}-${PV}" 73S="${WORKDIR}/${VDRPLUGIN}-${PV}"
61 74
62# depend on headers for DVB-driver 75# depend on headers for DVB-driver
63RDEPEND="" 76DEPEND=">=media-tv/gentoo-vdr-scripts-0.3.8
77 || ( >=media-tv/gentoo-vdr-scripts-0.4.2 >=media-tv/vdrplugin-rebuild-0.2 )
78 >=app-admin/eselect-vdr-0.0.2
64DEPEND="media-tv/linuxtv-dvb-headers" 79 media-tv/linuxtv-dvb-headers"
65 80
66# Where should the plugins live in the filesystem
67VDR_PLUGIN_DIR="/usr/lib/vdr/plugins"
68 81
69VDR_RC_DIR="/usr/lib/vdr/rcscript" 82# New method of storing plugindb
70 83# Called from src_install
71# Pathes to includes 84# file maintained by normal portage-methods
72VDR_INCLUDE_DIR="/usr/include" 85create_plugindb_file() {
73DVB_INCLUDE_DIR="/usr/include"
74
75
76# this code is from linux-mod.eclass
77update_vdrplugindb() {
78 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/ 86 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
79 87 local DB_FILE="${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
80 if [[ ! -f ${VDRPLUGINDB_DIR}/vdrplugindb ]]; then
81 [[ ! -d ${VDRPLUGINDB_DIR} ]] && mkdir -p ${VDRPLUGINDB_DIR}
82 touch ${VDRPLUGINDB_DIR}/vdrplugindb
83 fi
84 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
85 einfo "Adding plugin to vdrplugindb."
86 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${VDRPLUGINDB_DIR}/vdrplugindb
87 fi
88}
89
90remove_vdrplugindb() {
91 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
92
93 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
94 einfo "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb."
95 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb
96 fi
97}
98
99vdr-plugin_pkg_setup() {
100 # -fPIC is needed for shared objects on some platforms (amd64 and others)
101 append-flags -fPIC
102 use debug && append-flags -g
103
104 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' /usr/include/vdr/config.h)
105 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' /usr/include/vdr/config.h)
106 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
107
108 einfo "Building ${PF} against vdr-${VDRVERSION}"
109 einfo "APIVERSION: ${APIVERSION}"
110}
111
112vdr-plugin_src_unpack() {
113 [ -z "$1" ] && vdr-plugin_src_unpack unpack patchmakefile
114
115 while [ "$1" ]; do
116
117 case "$1" in
118 unpack)
119 base_src_unpack
120 ;;
121 patchmakefile)
122 if ! cd ${S}; then
123 ewarn "There seems to be no plugin-directory with the name ${S##*/}"
124 ewarn "Perhaps you find one among these:"
125 cd "${WORKDIR}"
126 einfo "$(/bin/ls -1 ${WORKDIR})"
127 die "Could not change to plugin-source-directory!"
128 fi
129
130 ebegin "Patching Makefile"
131 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
132 sed -i.orig Makefile \
133 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
134 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
135 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
136 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
137 -e 's:^CXXFLAGS:#CXXFLAGS:' \
138 -e 's:-I$(VDRDIR)/include:-I$(VDRDIR):' \
139 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
140 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):' \
141 -e 's:$(VDRDIR)/\([a-z]*\.h\|Make.config\):$(VDRDIR)/vdr/\1:' \
142 -e 's:^APIVERSION = :APIVERSION ?= :' \
143 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
144 -e '1i\APIVERSION = '"${APIVERSION}"
145 eend $?
146 ;;
147 esac
148
149 shift
150 done
151}
152
153vdr-plugin_copy_source_tree() {
154 cp -r ${S} ${T}/source-tree
155 cd ${T}/source-tree
156 mv Makefile.orig Makefile
157 sed -i Makefile \
158 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
159 -e 's:^CXXFLAGS:#CXXFLAGS:' \
160 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
161 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
162}
163
164vdr-plugin_install_source_tree() {
165 einfo "Installing sources"
166 destdir=${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}
167 insinto ${destdir}-${PV}
168 doins -r ${T}/source-tree/*
169
170 dosym ${VDRPLUGIN}-${PV} ${destdir}
171}
172
173vdr-plugin_src_compile() {
174 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
175
176 while [ "$1" ]; do
177
178 case "$1" in
179 prepare)
180 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
181 ;;
182 compile)
183 cd ${S}
184
185 emake ${VDRPLUGIN_MAKE_TARGET:-all} || die "emake failed"
186 ;;
187 esac
188
189 shift
190 done
191}
192
193vdr-plugin_src_install() {
194 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
195 cd ${S}
196
197 insinto "${VDR_PLUGIN_DIR}" 88 insinto "${NEW_VDRPLUGINDB_DIR}"
198 doins libvdr-*.so.*
199 dodoc README* HISTORY CHANGELOG
200 89
90# BUG: portage-2.1.4_rc9 will delete the EBUILD= line, so we cannot use this code.
91# cat <<-EOT > "${D}/${DB_FILE}"
92# VDRPLUGIN_DB=1
93# CREATOR=ECLASS
94# EBUILD=${CATEGORY}/${PN}
95# EBUILD_V=${PVR}
96# EOT
97 {
98 echo "VDRPLUGIN_DB=1"
99 echo "CREATOR=ECLASS"
100 echo "EBUILD=${CATEGORY}/${PN}"
101 echo "EBUILD_V=${PVR}"
102 } > "${D}/${DB_FILE}"
103}
201 104
202 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it 105# Delete files created outside of vdr-plugin.eclass
203 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd 106# vdrplugin-rebuild.ebuild converted plugindb and files are
107# not deleted by portage itself - should only be needed as
108# long as not every system has switched over to
109# vdrplugin-rebuild-0.2 / gentoo-vdr-scripts-0.4.2
110delete_orphan_plugindb_file() {
111 #elog Testing for orphaned plugindb file
112 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
113 local DB_FILE="${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
204 114
205 if [[ -n ${VDR_CONFD_FILE} ]]; then 115 # file exists
206 insinto /etc/conf.d 116 [[ -f ${DB_FILE} ]] || return
207 newins "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN}
208 fi
209 117
118 # will portage handle the file itself
119 if grep -q CREATOR=ECLASS "${DB_FILE}"; then
120 #elog file owned by eclass - don't touch it
121 return
122 fi
210 123
211 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it 124 elog "Removing orphaned plugindb-file."
212 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh 125 elog "\t#rm ${DB_FILE}"
126 rm "${DB_FILE}"
127}
213 128
214 if [[ -n ${VDR_RCADDON_FILE} ]]; then 129
130create_header_checksum_file()
131{
132 # Danger: Not using $ROOT here, as compile will also not use it !!!
133 # If vdr in $ROOT and / differ, plugins will not run anyway
134
215 insinto "${VDR_RC_DIR}" 135 insinto "${VDR_CHECKSUM_DIR}"
216 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh 136 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
217 fi 137 newins "${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN}"
218
219
220
221 insinto /usr/lib/vdr/checksums
222 if [[ -f ${ROOT}/usr/lib/vdr/checksums/header-md5-vdr ]]; then
223 newins ${ROOT}/usr/lib/vdr/checksums/header-md5-vdr header-md5-${PN}
224 else 138 else
225 if which md5sum >/dev/null 2>&1; then 139 if type -p md5sum >/dev/null 2>&1; then
226 cd ${S} 140 cd "${S}"
227 ( 141 (
228 cd ${ROOT}${VDR_INCLUDE_DIR}/vdr 142 cd "${VDR_INCLUDE_DIR}"
229 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2 143 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
230 ) > header-md5-${PN} 144 ) > header-md5-${PN}
231 doins header-md5-${PN} 145 doins header-md5-${PN}
232 fi 146 fi
233 fi 147 fi
234}
235
236vdr-plugin_pkg_postinst() {
237 update_vdrplugindb
238 einfo
239 einfo "The vdr plugin ${VDRPLUGIN} has now been installed."
240 einfo "To activate execute the following command:"
241 einfo
242 einfo " emerge --config ${PN}"
243 einfo
244 if [[ -n "${VDR_CONFD_FILE}" ]]; then
245 einfo "And have a look at the config-file"
246 einfo "/etc/conf.d/vdr.${VDRPLUGIN}"
247 einfo
248 fi
249}
250
251vdr-plugin_pkg_postrm() {
252 remove_vdrplugindb
253}
254
255vdr-plugin_pkg_config_final() {
256 diff ${conf_orig} ${conf}
257 rm ${conf_orig}
258}
259
260vdr-plugin_pkg_config() {
261 if [[ -z "${INSTALLPLUGIN}" ]]; then
262 INSTALLPLUGIN="${VDRPLUGIN}"
263 fi
264 # First test if plugin is already inside PLUGINS
265 local conf=/etc/conf.d/vdr
266 conf_orig=${conf}.before_emerge_config
267 cp ${conf} ${conf_orig}
268
269 einfo "Reading ${conf}"
270 if ! grep -q "^PLUGINS=" ${conf}; then
271 local LINE=$(sed ${conf} -n -e '/^#.*PLUGINS=/=' | tail -n 1)
272 if [[ -n "${LINE}" ]]; then
273 sed -e ${LINE}'a PLUGINS=""' -i ${conf}
274 else
275 echo 'PLUGINS=""' >> ${conf}
276 fi
277 unset LINE
278 fi
279
280 unset PLUGINS
281 PLUGINS=$(source /etc/conf.d/vdr; echo ${PLUGINS})
282
283 active=0
284 for p in ${PLUGINS}; do
285 if [[ "${p}" == "${INSTALLPLUGIN}" ]]; then
286 active=1
287 break;
288 fi
289 done
290
291 if [[ "${active}" == "1" ]]; then
292 einfo "${INSTALLPLUGIN} already activated"
293 echo
294 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
295 if [[ "${answer}" != "yes" ]]; then
296 einfo "aborted"
297 return
298 fi
299 einfo "Removing ${INSTALLPLUGIN} from active plugins."
300 local LINE=$(sed ${conf} -n -e '/^PLUGINS=.*\<'${INSTALLPLUGIN}'\>/=' | tail -n 1)
301 sed -i ${conf} -e ${LINE}'s/\<'${INSTALLPLUGIN}'\>//' \
302 -e ${LINE}'s/ \( \)*/ /g' \
303 -e ${LINE}'s/ "/"/g' \
304 -e ${LINE}'s/" /"/g'
305
306 vdr-plugin_pkg_config_final
307 return
308 fi
309
310
311 einfo "Adding ${INSTALLPLUGIN} to active plugins."
312 local LINE=$(sed ${conf} -n -e '/^PLUGINS=/=' | tail -n 1)
313 sed -i ${conf} -e ${LINE}'s/^PLUGINS=" *\(.*\)"/PLUGINS="\1 '${INSTALLPLUGIN}'"/' \
314 -e ${LINE}'s/ \( \)*/ /g' \
315 -e ${LINE}'s/ "/"/g' \
316 -e ${LINE}'s/" /"/g'
317
318 vdr-plugin_pkg_config_final
319} 148}
320 149
321fix_vdr_libsi_include() 150fix_vdr_libsi_include()
322{ 151{
323 einfo "Fixing include of libsi-headers" 152 einfo "Fixing include of libsi-headers"
327 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \ 156 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
328 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:' 157 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
329 done 158 done
330} 159}
331 160
161vdr_patchmakefile() {
162 einfo "Patching Makefile"
163 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
164 cp Makefile "${WORKDIR}"/Makefile.before
165
166 ebegin " Setting Pathes"
167 sed -i Makefile \
168 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
169 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
170 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
171 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \
172 -e "/^DVBDIR/d" \
173 -e 's:-I$(DVBDIR)/include::'
174 eend $?
175
176 # maybe needed for multiproto:
177 #sed -i Makefile \
178 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
179 # -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
180 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
181
182 if ! grep -q APIVERSION Makefile; then
183 ebegin " Converting to APIVERSION"
184 sed -i Makefile \
185 -e 's:^APIVERSION = :APIVERSION ?= :' \
186 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
187 -e '/VDRVERSION =/a\APIVERSION = $(shell sed -ne '"'"'/define APIVERSION/s/^.*"\\(.*\\)".*$$/\\1/p'"'"' $(VDRDIR)/config.h)'
188 eend $?
189 fi
190
191 # Correcting Compile-Flags
192 # Do not overwrite CXXFLAGS, add LDFLAGS if missing
193 sed -i Makefile \
194 -e '/^CXXFLAGS[[:space:]]*=/s/=/?=/' \
195 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
196
197 # Disabling file stripping, useful for debugging
198 sed -i Makefile \
199 -e '/@.*strip/d' \
200 -e '/strip \$(LIBDIR)\/\$@/d' \
201 -e '/@.*\$(STRIP)/d'
202
203 # Use a file instead of a variable as single-stepping via ebuild
204 # destroys environment.
205 touch "${WORKDIR}"/.vdr-plugin_makefile_patched
206}
207
208vdr_add_local_patch() {
209 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
210 echo
211 einfo "Applying local patches"
212 for LOCALPATCH in "${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}"/*.{diff,patch}; do
213 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
214 done
215 fi
216}
217
218vdr_has_gettext() {
219 has_version ">=media-video/vdr-1.5.7"
220}
221
222plugin_has_gettext() {
223 [[ -d po ]]
224}
225
226vdr_i18n_convert_to_gettext() {
227 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
228
229 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
230 ewarn "Conversion to gettext disabled in ebuild"
231 return 1
232 fi
233
234 if [[ ! -x ${i18n_tool} ]]; then
235 eerror "Missing ${i18n_tool}"
236 eerror "Please re-emerge vdr"
237 die "Missing ${i18n_tool}"
238 fi
239
240 ebegin "Auto converting translations to gettext"
241 # call i18n-to-gettext tool
242 # take all texts missing tr call into special file
243 "${i18n_tool}" 2>/dev/null \
244 |sed -e '/^"/!d' \
245 -e '/^""$/d' \
246 -e 's/\(.*\)/trNOOP(\1)/' \
247 > dummy-translations-trNOOP.c
248
249 # if there were untranslated texts just run it again
250 # now the missing calls are listed in
251 # dummy-translations-trNOOP.c
252 if [[ -s dummy-translations-trNOOP.c ]]; then
253 "${i18n_tool}" &>/dev/null
254 fi
255
256 # now use the modified Makefile
257 if [[ -f Makefile.new ]]; then
258 mv Makefile.new Makefile
259 eend 0 ""
260 else
261 eend 1 "Conversion to gettext failed. Plugin needs fixing."
262 return 1
263 fi
264}
265
266vdr_i18n_disable_gettext() {
267 # Remove i18n Target if using older vdr
268 sed -i Makefile \
269 -e '/^all:/s/ i18n//'
270 eend 0
271}
272
273vdr_i18n() {
274 if vdr_has_gettext; then
275 einfo "VDR has gettext support"
276 if plugin_has_gettext; then
277 einfo "Plugin has gettext support, fine"
278 else
279 vdr_i18n_convert_to_gettext
280 if [[ $? != 0 ]]; then
281 ewarn ""
282 ewarn "Plugin will have only english OSD texts"
283 ewarn "it needs manual fixing."
284 fi
285 fi
286 else
287 einfo "VDR has no gettext support"
288 if plugin_has_gettext; then
289 vdr_i18n_disable_gettext
290 fi
291 fi
292}
293
294vdr-plugin_copy_source_tree() {
295 pushd . >/dev/null
296 cp -r "${S}" "${T}"/source-tree
297 cd "${T}"/source-tree
298 cp "${WORKDIR}"/Makefile.before Makefile
299 sed -i Makefile \
300 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
301 -e 's:^CXXFLAGS:#CXXFLAGS:' \
302 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
303 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
304 popd >/dev/null
305}
306
307vdr-plugin_install_source_tree() {
308 einfo "Installing sources"
309 destdir="${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}"
310 insinto "${destdir}-${PV}"
311 doins -r "${T}"/source-tree/*
312
313 dosym "${VDRPLUGIN}-${PV}" "${destdir}"
314}
315
316vdr-plugin_print_enable_command() {
317 elog
318 elog "To activate this vdr-plugin execute the following command:"
319 elog "\teselect vdr-plugin enable ${PN#vdr-}"
320 elog
321}
322
323
324## exported functions
325
326vdr-plugin_pkg_setup() {
327 # -fPIC is needed for shared objects on some platforms (amd64 and others)
328 append-flags -fPIC
329
330 # Where should the plugins live in the filesystem
331 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
332 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
333
334 # was /usr/lib/... some time ago
335 # since gentoo-vdr-scripts-0.3.6 it works with /usr/share/...
336 VDR_RC_DIR="/usr/share/vdr/rcscript"
337
338 # Pathes to includes
339 VDR_INCLUDE_DIR="/usr/include/vdr"
340 DVB_INCLUDE_DIR="/usr/include"
341
342
343 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
344 LOCDIR="/usr/share/vdr/locale"
345
346 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
347 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
348 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
349
350 einfo "Compiling against"
351 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]"
352}
353
354vdr-plugin_src_unpack() {
355 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
356 eerror "Wrong use of vdr-plugin.eclass."
357 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
358 echo
359 eerror "Please report this at bugs.gentoo.org."
360 die "vdr-plugin_pkg_setup not called!"
361 fi
362 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile i18n
363
364 while [ "$1" ]; do
365
366 case "$1" in
367 all_but_unpack)
368 vdr-plugin_src_unpack add_local_patch patchmakefile i18n
369 ;;
370 unpack)
371 base_src_unpack
372 ;;
373 add_local_patch)
374 cd "${S}" || die "Could not change to plugin-source-directory!"
375 vdr_add_local_patch
376 ;;
377 patchmakefile)
378 cd "${S}" || die "Could not change to plugin-source-directory!"
379 vdr_patchmakefile
380 ;;
381 i18n)
382 cd "${S}" || die "Could not change to plugin-source-directory!"
383 vdr_i18n
384 ;;
385 esac
386
387 shift
388 done
389}
390
391vdr-plugin_src_compile() {
392 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
393
394 while [ "$1" ]; do
395
396 case "$1" in
397 prepare)
398 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
399 ;;
400 compile)
401 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
402 eerror "Wrong use of vdr-plugin.eclass."
403 eerror "An ebuild for a vdr-plugin will not work without"
404 eerror "calling vdr-plugin_src_unpack to patch the Makefile."
405 echo
406 eerror "Please report this at bugs.gentoo.org."
407 die "vdr-plugin_src_unpack not called!"
408 fi
409 cd "${S}"
410
411 emake ${BUILD_PARAMS} \
412 ${VDRPLUGIN_MAKE_TARGET:-all} \
413 LOCALEDIR="${TMP_LOCALE_DIR}" \
414 || die "emake failed"
415 ;;
416 esac
417
418 shift
419 done
420}
421
422vdr-plugin_src_install() {
423 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
424 cd "${WORKDIR}"
425
426 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then
427 local mname="${P}-Makefile"
428 cp "${S}"/Makefile "${mname}.patched"
429 cp Makefile.before "${mname}.before"
430
431 diff -u "${mname}.before" "${mname}.patched" > "${mname}.diff"
432
433 insinto "/usr/share/vdr/maintainer-data/makefile-changes"
434 doins "${mname}.diff"
435
436 insinto "/usr/share/vdr/maintainer-data/makefile-before"
437 doins "${mname}.before"
438
439 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
440 doins "${mname}.patched"
441
442 fi
443
444 cd "${S}"
445 insinto "${VDR_PLUGIN_DIR}"
446 doins libvdr-*.so.*
447
448 if vdr_has_gettext && [[ -d ${TMP_LOCALE_DIR} ]]; then
449 einfo "Installing locales"
450 cd "${TMP_LOCALE_DIR}"
451 insinto "${LOCDIR}"
452 doins -r *
453 fi
454
455 cd "${S}"
456 local docfile
457 for docfile in README* HISTORY CHANGELOG; do
458 [[ -f ${docfile} ]] && dodoc ${docfile}
459 done
460
461 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it
462 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd
463
464 if [[ -n ${VDR_CONFD_FILE} ]]; then
465 newconfd "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN}
466 fi
467
468
469 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it
470 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh
471
472 if [[ -n ${VDR_RCADDON_FILE} ]]; then
473 insinto "${VDR_RC_DIR}"
474 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
475 fi
476
477 create_header_checksum_file
478 create_plugindb_file
479}
480
481vdr-plugin_pkg_postinst() {
482 vdr-plugin_print_enable_command
483
484 if [[ -n "${VDR_CONFD_FILE}" ]]; then
485 elog "Please have a look at the config-file"
486 elog "\t/etc/conf.d/vdr.${VDRPLUGIN}"
487 elog
488 fi
489}
490
491vdr-plugin_pkg_postrm() {
492 delete_orphan_plugindb_file
493}
494
495vdr-plugin_pkg_config() {
496 ewarn "emerge --config ${PN} is no longer supported"
497 vdr-plugin_print_enable_command
498}
499
332EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config 500EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config

Legend:
Removed from v.1.21  
changed lines
  Added in v.1.56

  ViewVC Help
Powered by ViewVC 1.1.20